<?php
defined('MOODLE_INTERNAL') || die();

if ($ADMIN->fulltree) {

    //--- settings ------------------------------------------------------------------------------------------
    $settings->add(new admin_setting_heading('enrol_posir_settings', '', get_string('pluginname_desc', 'enrol_posir')));

    $settings->add(new admin_setting_configtext('enrol_posir/merchant_id',
                   get_string('merchant_id', 'enrol_posir'),
                   'Copy API Login ID from merchant account & paste here', '', PARAM_RAW));;
    $settings->add(new admin_setting_configcheckbox('enrol_posir/checkproductionmode',
                   get_string('checkproductionmode', 'enrol_posir'), '', 0));

    $settings->add(new admin_setting_configcheckbox('enrol_posir/useposir',
                   get_string('useposir', 'enrol_posir'), get_string('useposir_description', 'enrol_posir'), 0));

    $settings->add(new admin_setting_configcheckbox('enrol_posir/mailstudents', get_string('mailstudents', 'enrol_posir'), '', 0));

    $settings->add(new admin_setting_configcheckbox('enrol_posir/mailteachers', get_string('mailteachers', 'enrol_posir'), '', 0));

    $settings->add(new admin_setting_configcheckbox('enrol_posir/mailadmins', get_string('mailadmins', 'enrol_posir'), '', 0));

    // Note: let's reuse the ext sync constants and strings here, internally it is very similar,
    //       it describes what should happen when users are not supposed to be enrolled any more.
    $options = array(
        ENROL_EXT_REMOVED_KEEP           => get_string('extremovedkeep', 'enrol'),
        ENROL_EXT_REMOVED_SUSPENDNOROLES => get_string('extremovedsuspendnoroles', 'enrol'),
        ENROL_EXT_REMOVED_UNENROL        => get_string('extremovedunenrol', 'enrol'),
    );
    $settings->add(new admin_setting_configselect('enrol_posir/expiredaction', get_string('expiredaction', 'enrol_posir'), get_string('expiredaction_help', 'enrol_posir'), ENROL_EXT_REMOVED_SUSPENDNOROLES, $options));

    //--- enrol instance defaults ----------------------------------------------------------------------------
    $settings->add(new admin_setting_heading('enrol_posir_defaults',
        get_string('enrolinstancedefaults', 'admin'), get_string('enrolinstancedefaults_desc', 'admin')));

    $options = array(ENROL_INSTANCE_ENABLED  => get_string('yes'),
                     ENROL_INSTANCE_DISABLED => get_string('no'));
    $settings->add(new admin_setting_configselect('enrol_posir/status',
        get_string('status', 'enrol_posir'), get_string('status_desc', 'enrol_posir'), ENROL_INSTANCE_DISABLED, $options));

    $settings->add(new admin_setting_configtext('enrol_posir/cost', get_string('cost', 'enrol_posir'), '', 0, PARAM_FLOAT, 4));

    $posircurrencies = enrol_get_plugin('posir')->get_currencies();
    $settings->add(new admin_setting_configselect('enrol_posir/currency', get_string('currency', 'enrol_posir'), '', 'USD', $posircurrencies));

    if (!during_initial_install()) {
        $options = get_default_enrol_roles(context_system::instance());
        $student = get_archetype_roles('student');
        $student = reset($student);
        $settings->add(new admin_setting_configselect('enrol_posir/roleid',
            get_string('defaultrole', 'enrol_posir'), get_string('defaultrole_desc', 'enrol_posir'), $student->id, $options));
    }

    $settings->add(new admin_setting_configduration('enrol_posir/enrolperiod',
        get_string('enrolperiod', 'enrol_posir'), get_string('enrolperiod_desc', 'enrol_posir'), 0));
}
